## Script (Python) "getRetStudentStatistics"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=session_id=None
##title=
##
# $Id: getPaymentStatistics.py 5560 2010-10-06 08:05:01Z henrik $
"""
return Payment Statistics
"""

from Products.AdvancedQuery import Eq, Between, Le,In

import logging
logger = logging.getLogger('Skins.getPaymentStatistics')

import DateTime,csv

member = context.portal_membership.getAuthenticatedMember()
logger.info('%s invoked statistics' % member)
if not context.isStaff():
    return

ARTS = ('CRS','ISS','HIS','MUS','ECO','GEO','POL','SOS','CCA','ECU','THA','GED','GSE','PES','SPC','ENG ','FRE','ARB','HAU','IGB','YOR')

#SCS = ('BIO','CHE','HED','MAT','PED','PHY ','CSC','ISC','PHE','AGE','BED','HEC','TED','FAA')

catA =      (      'school_fee_paid',
                   'courses_registered',
                   'courses_validated',
                   )
                   
if not session_id:
    session_id  = context.getSessionId()[0]

L1 = ('100','110','120')
L2 = ('200','210','220')
L3 = ('300','310','320')
L4 = ('400','410','420')
L5 = ('500','510','520')
L6 = ('600','610','620')

d = {}

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','pd_ft')
d['pd_ft'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','prence') & In('department',ARTS)
d['prence_arts'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','prence') & ~In('department',ARTS)
d['prence_sci'] = len(context.students_catalog.evalAdvancedQuery(query))

# regular students

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & In('department',ARTS) & In('level',L1)
d['ug_ft_arts_100'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & ~In('department',ARTS) & In('level',L1)
d['ug_ft_sci_100'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & In('department',ARTS) & In('level',L2)
d['ug_ft_arts_200'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & ~In('department',ARTS) & In('level',L2)
d['ug_ft_sci_200'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & In('department',ARTS) & In('level',L3)
d['ug_ft_arts_300'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & ~In('department',ARTS) & In('level',L3)
d['ug_ft_sci_300'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & In('department',ARTS) & In('level',L4)
d['ug_ft_arts_rep'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_ft') & ~In('department',ARTS) & In('level',L4)
d['ug_ft_sci_rep'] = len(context.students_catalog.evalAdvancedQuery(query))

# sandwich

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L1)
d['ug_sw_arts_100'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L1)
d['ug_sw_sci_100'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L2)
d['ug_sw_arts_200'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L2)
d['ug_sw_sci_200'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L3)
d['ug_sw_arts_300'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L3)
d['ug_sw_sci_300'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L4)
d['ug_sw_arts_400'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L4)
d['ug_sw_sci_400'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L5)
d['ug_sw_arts_500'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L5)
d['ug_sw_sci_500'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & In('department',ARTS) & In('level',L6)
d['ug_sw_arts_rep'] = len(context.students_catalog.evalAdvancedQuery(query))

query = Eq('session',session_id) & In('review_state',catA) & Eq('mode','ug_sw') & ~In('department',ARTS) & In('level',L6)
d['ug_sw_sci_rep'] = len(context.students_catalog.evalAdvancedQuery(query))


l = []
l += d,

csv_name = context.waeup_tool.dumpListToCSV(l,'payments_statistics')
logger.info('%s dumped payments statistics to %s' % (member,csv_name))

return d
